<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>CustomerRegistrationService.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">testing</a> &gt; <a href="index.source.html" class="el_package">com.softwaretesting.testing.customerRegistration.service</a> &gt; <span class="el_source">CustomerRegistrationService.java</span></div><h1>CustomerRegistrationService.java</h1><pre class="source lang-java linenums">package com.softwaretesting.testing.customerRegistration.service;

import com.softwaretesting.testing.exception.BadRequestException;
import com.softwaretesting.testing.dao.CustomerRepository;
import com.softwaretesting.testing.model.Customer;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Optional;

@Service
public class CustomerRegistrationService {

    private final CustomerRepository customerRepository;

    @Autowired
<span class="fc" id="L18">    public CustomerRegistrationService(CustomerRepository customerRepository) {</span>
<span class="fc" id="L19">        this.customerRepository = customerRepository;</span>
<span class="fc" id="L20">    }</span>


    @Transactional(rollbackFor = Exception.class)
    public Customer registerNewCustomer(Customer customer) {
<span class="fc" id="L25">        Optional&lt;Customer&gt; existsPhoneNumber = customerRepository.selectCustomerByPhoneNumber(customer.getPhoneNumber());</span>

        //TODO: Validate customer phone number

<span class="fc bfc" id="L29" title="All 2 branches covered.">        if (existsPhoneNumber.isPresent()) {</span>
<span class="fc" id="L30">            Customer existingCustomer = existsPhoneNumber.get();</span>
<span class="pc bpc" id="L31" title="1 of 2 branches missed.">            if (existingCustomer.getName().equals(customer.getName())){</span>
<span class="fc" id="L32">                throw new IllegalStateException(&quot;You are already registered&quot;);</span>
            }
<span class="nc" id="L34">            throw new BadRequestException(</span>
<span class="nc" id="L35">                    &quot;Phone Number &quot; + customer.getPhoneNumber() + &quot; taken&quot;);</span>
        }

<span class="fc" id="L38">        return customerRepository.save(customer);</span>
    }
}






</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.10.202304240956</span></div></body></html>